/*
 * MIT License
 *
 * Copyright (c) 2018-2019 Daniel Cortes
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */

package danielcortes.xyz;

import danielcortes.xyz.controllers.MainController;
import danielcortes.xyz.data.Configuration;
import danielcortes.xyz.views.MainView;

import javax.swing.*;
import java.io.FileInputStream;
import java.io.IOException;
import java.util.Locale;
import java.util.logging.LogManager;

public class Main {
    static {
        setUpLogger();
        setUpSystemProperties();
    }

    public static void main(String[] args) {
        run();
    }

    private static void run() {
        MainView view = new MainView();
        MainController mainController = new MainController(view);

        executeView(view.getContentPanel());
    }

    private static void executeView(JComponent view) {
        JFrame frame = new JFrame(Configuration.get("nombre_caja"));
        frame.setContentPane(view);
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        frame.setSize(250,500);
        frame.setLocationRelativeTo(null);
        frame.setVisible(true);
    }

    private static void setUpSystemProperties() {
        System.setProperty("awt.useSystemAAFontSettings", "on");
        System.setProperty("swing.aatext", "true");

        try {
            UIManager.setLookAndFeel(Configuration.get("look_and_feel"));
        } catch (ClassNotFoundException | InstantiationException | IllegalAccessException | UnsupportedLookAndFeelException e) {
            e.printStackTrace();
        }

        Locale.setDefault(new Locale("es"));
    }

    private static void setUpLogger() {
        LogManager manager = LogManager.getLogManager();
        try {
            FileInputStream in = new FileInputStream("config/logging.properties");
            manager.readConfiguration(in);
            in.close();
        } catch (IOException e) {
            System.exit(1);
        }


    }
}
